## dracut 106

=== Makefile ===
-include dracut-version.sh

DRACUT_MAIN_VERSION ?= $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --abbrev=0 --tags --always 2>/dev/null || :)
ifeq ($(DRACUT_MAIN_VERSION),)
DRACUT_MAIN_VERSION = $(DRACUT_VERSION)
endif
DRACUT_FULL_VERSION ?= $(shell env GIT_CEILING_DIRECTORIES=$(CURDIR)/.. git describe --tags --always 2>/dev/null || :)
ifeq ($(DRACUT_FULL_VERSION),)
DRACUT_FULL_VERSION = $(DRACUT_VERSION)
endif

HAVE_SHELLCHECK ?= $(shell command -v shellcheck >/dev/null 2>&1 && echo yes)
HAVE_SHFMT ?= $(shell command -v shfmt >/dev/null  2>&1 && echo yes)

-include Makefile.inc

KVERSION ?= $(shell uname -r)

prefix ?= /usr
libdir ?= ${prefix}/lib
datadir ?= ${prefix}/share
pkglibdir ?= ${libdir}/dracut
sysconfdir ?= ${prefix}/etc
bindir ?= ${prefix}/bin
mandir ?= ${prefix}/share/man
CFLAGS ?= -O2 -g -Wall -std=gnu99 -D_FILE_OFFSET_BITS=64 -Wformat -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2
bashcompletiondir ?= ${datadir}/bash-completion/completions
pkgconfigdatadir ?= $(datadir)/pkgconfig

man1pages = man/lsinitrd.1

man5pages = man/dracut.conf.5

man7pages = man/dracut.cmdline.7 \
            man/dracut.bootup.7 \
            man/dracut.modules.7

man8pages = man/dracut.8 \
            man/dracut-catimages.8 \
            modules.d/98dracut-systemd/dracut-cmdline.service.8 \
            modules.d/98dracut-systemd/dracut-initqueue.service.8 \
            modules.d/98dracut-systemd/dracut-mount.service.8 \
            modules.d/98dracut-systemd/dracut-shutdown.service.8 \
            modules.d/98dracut-systemd/dracut-pre-mount.service.8 \
            modules.d/98dracut-systemd/dracut-pre-pivot.service.8 \
            modules.d/98dracut-systemd/dracut-pre-trigger.service.8 \
            modules.d/98dracut-systemd/dracut-pre-udev.service.8

manpages = $(man1pages) $(man5pages) $(man7pages) $(man8pages)

.PHONY: install clean archive test all check AUTHORS CONTRIBUTORS doc

all: dracut.pc dracut-install src/skipcpio/skipcpio dracut-util

%.o : %.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(KMOD_CFLAGS) $< -o $@

DRACUT_INSTALL_OBJECTS = \
        src/install/dracut-install.o \
        src/install/hashmap.o\
        src/install/log.o \
        src/install/strv.o \
        src/install/util.o

# deps generated with gcc -MM
src/install/dracut-install.o: src/install/dracut-install.c src/install/log.h src/install/macro.h \
	src/install/hashmap.h src/install/util.h
src/install/hashmap.o: src/install/hashmap.c src/install/util.h src/install/macro.h src/install/log.h \
	src/install/hashmap.h
src/install/log.o: src/install/log.c src/install/log.h src/install/macro.h src/install/util.h
src/install/util.o: src/install/util.c src/install/util.h src/install/macro.h src/install/log.h
src/install/strv.o: src/install/strv.c src/install/strv.h src/install/util.h src/install/macro.h src/install/log.h

src/install/dracut-install: $(DRACUT_INSTALL_OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(DRACUT_INSTALL_OBJECTS) $(LDLIBS) $(FTS_LIBS) $(KMOD_LIBS)

dracut-install: src/install/dracut-install
	ln -fs $< $@

SKIPCPIO_OBJECTS = src/skipcpio/skipcpio.o
skipcpio/skipcpio.o: src/skipcpio/skipcpio.c
skipcpio/skipcpio: $(SKIPCPIO_OBJECTS)

UTIL_OBJECTS = src/util/util.o
util/util.o: src/util/util.c
util/util: $(UTIL_OBJECTS)

dracut-util: src/util/util
	cp -a $< $@

.PHONY: indent-c
indent-c:
	astyle -n --quiet --options=.astylerc $(wildcard *.[ch] */*.[ch] src/*/*.[ch])

.PHONY: indent
indent: indent-c
ifeq ($(HAVE_SHFMT),yes)
	shfmt -w -s .
endif

src/dracut-cpio/target/release/dracut-cpio: src/dracut-cpio/src/main.rs
	cargo --offline build --release --manifest-path src/dracut-cpio/Cargo.toml

dracut-cpio: src/dracut-cpio/target/release/dracut-cpio
	ln -fs $< $@

ifeq ($(enable_dracut_cpio),yes)
all: dracut-cpio
endif

doc: $(manpages)

ifneq ($(enable_documentation),no)
all: doc
endif

%: %.xml
	@rm -f -- "$@"
	xsltproc -o "$@" -nonet http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl $<

%.xml: %.adoc
	@rm -f -- "$@"
	asciidoc -f man/asciidoc.conf -a "version=$(DRACUT_FULL_VERSION)" -d manpage -b docbook -o "$@" $<

# If ANOTRA_BIN not set, default to look for "npx" to run "npx antora".  If we
# end up with undefined ANTORA_BIN (i.e. not set and npx not found), we'll give
# a sane error when building docs below.
ifeq ($(ANTORA_BIN),)
NPX := $(shell command -v npx 2> /dev/null)
ifneq ($(NPX),)
ANTORA_BIN := "$(NPX) antora"
endif
endif
.PHONY: doc_site
doc_site: $(manpages) doc_site/modules/ROOT/nav.adoc doc_site/modules/ROOT/pages/index.adoc
ifndef ANTORA_BIN
	$(error Antora not found, install nodejs or set ANTORA_BIN to make doc site)
endif
	mkdir -p doc_site/modules/ROOT/pages/man
	cd doc_site/modules/ROOT/pages/man/; for i in $(manpages) man/dracut.usage; do ln -sf ../../../../../$${i}.adoc $(basename $i); done
	$(shell echo $(ANTORA_BIN)) --attribute "mainversion=$(DRACUT_MAIN_VERSION)" \
	  --attribute "version=${DRACUT_FULL_VERSION}" \
	  antora-playbook.yml

dracut.8: man/dracut.8.adoc \
	man/dracut.usage.adoc

dracut.pc: Makefile.inc Makefile
	@echo "Name: dracut" > dracut.pc
	@echo "Description: dracut" >> dracut.pc
	@echo "Version: $(DRACUT_FULL_VERSION)" >> dracut.pc
	@echo "dracutdir=$(pkglibdir)" >> dracut.pc
	@echo "dracutmodulesdir=$(pkglibdir)/modules.d" >> dracut.pc
	@echo "dracutconfdir=$(pkglibdir)/dracut.conf.d" >> dracut.pc

install: all
	mkdir -p $(DESTDIR)$(pkglibdir)
	mkdir -p $(DESTDIR)$(bindir)
	mkdir -p $(DESTDIR)$(sysconfdir)
	mkdir -p $(DESTDIR)$(pkglibdir)/modules.d
	mkdir -p $(DESTDIR)$(mandir)/man1 $(DESTDIR)$(mandir)/man5 $(DESTDIR)$(mandir)/man7 $(DESTDIR)$(mandir)/man8
	install -m 0755 dracut.sh $(DESTDIR)$(bindir)/dracut
	install -m 0755 dracut-catimages.sh $(DESTDIR)$(bindir)/dracut-catimages
	install -m 0755 lsinitrd.sh $(DESTDIR)$(bindir)/lsinitrd
	install -m 0644 dracut.conf $(DESTDIR)$(sysconfdir)/dracut.conf
	mkdir -p $(DESTDIR)$(sysconfdir)/dracut.conf.d
	mkdir -p $(DESTDIR)$(pkglibdir)/dracut.conf.d
	install -m 0755 dracut-init.sh $(DESTDIR)$(pkglibdir)/dracut-init.sh
	install -m 0755 dracut-functions.sh $(DESTDIR)$(pkglibdir)/dracut-functions.sh
	install -m 0755 dracut-version.sh $(DESTDIR)$(pkglibdir)/dracut-version.sh
	ln -fs dracut-functions.sh $(DESTDIR)$(pkglibdir)/dracut-functions
	install -m 0755 dracut-logger.sh $(DESTDIR)$(pkglibdir)/dracut-logger.sh
	install -m 0755 dracut-initramfs-restore.sh $(DESTDIR)$(pkglibdir)/dracut-initramfs-restore
	rm -rf $(DESTDIR)$(pkglibdir)/modules.d/80test*
	cp -arx modules.d dracut.conf.d $(DESTDIR)$(pkglibdir)
	for i in $(configprofile) ; do \
		cp -arx dracut.conf.d/$$i/* $(DESTDIR)$(pkglibdir)/dracut.conf.d/ ;\
	done
ifneq ($(enable_test),no)
	cp -arx test $(DESTDIR)$(pkglibdir)
else
	rm -rf $(DESTDIR)$(pkglibdir)/modules.d/80test*
endif
ifneq ($(enable_documentation),no)
	for i in $(man1pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man1/$${i##*/}; done
	for i in $(man5pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man5/$${i##*/}; done
	for i in $(man7pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man7/$${i##*/}; done
	for i in $(man8pages); do install -m 0644 $$i $(DESTDIR)$(mandir)/man8/$${i##*/}; done
	ln -fs dracut.cmdline.7 $(DESTDIR)$(mandir)/man7/dracut.kernel.7
endif
	if [ -n "$(systemdsystemunitdir)" ]; then \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir); \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/98dracut-systemd/dracut-shutdown-onfailure.service $(DESTDIR)$(systemdsystemunitdir)/dracut-shutdown-onfailure.service; \
		ln -srf $(DESTDIR)$(pkglibdir)/modules.d/98dracut-systemd/dracut-shutdown.service $(DESTDIR)$(systemdsystemunitdir)/dracut-shutdown.service; \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir)/sysinit.target.wants; \
		ln -sf ../dracut-shutdown.service \
		$(DESTDIR)$(systemdsystemunitdir)/sysinit.target.wants/dracut-shutdown.service; \
		mkdir -p $(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants; \
		for i in \
		    dracut-cmdline.service \
		    dracut-initqueue.service \
		    dracut-mount.service \
		    dracut-pre-mount.service \
		    dracut-pre-pivot.service \
		    dracut-pre-trigger.service \
		    dracut-pre-udev.service \
		    ; do \
			ln -srf $(DESTDIR)$(pkglibdir)/modules.d/98dracut-systemd/$$i $(DESTDIR)$(systemdsystemunitdir); \
			ln -sf ../$$i \
			$(DESTDIR)$(systemdsystemunitdir)/initrd.target.wants/$$i; \
		done \
	fi
	if [ -f src/install/dracut-install ]; then \
		install -m 0755 src/install/dracut-install $(DESTDIR)$(pkglibdir)/dracut-install; \
	fi
	if [ -f src/skipcpio/skipcpio ]; then \
		install -m 0755 src/skipcpio/skipcpio $(DESTDIR)$(pkglibdir)/skipcpio; \
	fi
	if [ -f dracut-util ]; then \
		install -m 0755 dracut-util $(DESTDIR)$(pkglibdir)/dracut-util; \
	fi
ifeq ($(enable_dracut_cpio),yes)
	install -m 0755 dracut-cpio $(DESTDIR)$(pkglibdir)/dracut-cpio
endif
	mkdir -p $(DESTDIR)${prefix}/lib/kernel/install.d
	install -m 0755 install.d/50-dracut.install $(DESTDIR)${prefix}/lib/kernel/install.d/50-dracut.install
	install -m 0755 install.d/51-dracut-rescue.install $(DESTDIR)${prefix}/lib/kernel/install.d/51-dracut-rescue.install
	mkdir -p $(DESTDIR)${bashcompletiondir}
	install -m 0644 shell-completion/bash/dracut $(DESTDIR)${bashcompletiondir}/dracut
	install -m 0644 shell-completion/bash/lsinitrd $(DESTDIR)${bashcompletiondir}/lsinitrd
	mkdir -p $(DESTDIR)${pkgconfigdatadir}
	install -m 0644 dracut.pc $(DESTDIR)${pkgconfigdatadir}/dracut.pc
	if ! [ -n "$(systemdsystemunitdir)" ]; then \
		rm -rf $(DESTDIR)$(pkglibdir)/test/TEST-[0-9][0-9]-*SYSTEMD* ;\
		rm -rf $(DESTDIR)$(pkglibdir)/modules.d/*systemd* $(DESTDIR)$(mandir)/*.service.* ; \
		for i in bluetooth connman dbus* fido2 lvmmerge lvmthinpool-monitor memstrack network-manager pcsc pkcs11 rngd squash* tpm2-tss; do \
			rm -rf $(DESTDIR)$(pkglibdir)/modules.d/[0-9][0-9]$${i}; \
		done \
	fi

clean:
	$(RM) *~
	$(RM) */*~
	$(RM) */*/*~
	$(RM) $(manpages:%=%.xml) dracut.xml
	$(RM) dracut-*.tar.bz2 dracut-*.tar.xz
	$(RM) dracut-install src/install/dracut-install $(DRACUT_INSTALL_OBJECTS)
	$(RM) src/skipcpio/skipcpio $(SKIPCPIO_OBJECTS)
	$(RM) dracut-util src/util/util $(UTIL_OBJECTS)
	$(RM) $(manpages)
	$(RM) dracut.pc
	$(RM) dracut-cpio src/dracut-cpio/target/release/dracut-cpio*
	$(RM) -rf build/ doc_site/modules/ROOT/pages/man/*
	$(MAKE) -C test clean

syncheck:
	@ret=0;for i in dracut-initramfs-restore.sh modules.d/*/*.sh; do \
                [ "$${i##*/}" = "module-setup.sh" ] && continue; \
                read line < "$$i"; [ "$${line#*bash*}" != "$$line" ] && continue; \
		[ $$V ] && echo "posix syntax check: $$i"; bash --posix -n "$$i" ; ret=$$(($$ret+$$?)); \
		[ $$V ] && echo "checking for [[: $$i"; if grep -Fq '[[ ' "$$i" ; then ret=$$(($$ret+1)); echo "$$i contains [["; fi; \
		[ $$V ] && echo "checking for echo -n: $$i"; if grep -Fq 'echo -n ' "$$i" ; then ret=$$(($$ret+1)); echo "$$i contains echo -n"; fi \
	done;exit $$ret
	@ret=0;for i in *.sh modules.d/*/*.sh modules.d/*/module-setup.sh; do \
		[ $$V ] && echo "bash syntax check: $$i"; bash -n "$$i" ; ret=$$(($$ret+$$?)); \
	done;exit $$ret
ifeq ($(HAVE_SHELLCHECK),yes)
ifeq ($(HAVE_SHFMT),yes)
	shellcheck $$(shfmt -f .)
else
	find . -name '*.sh' -print0 | xargs -0 shellcheck
endif
endif

check: all
	@$(MAKE) -C test check

AUTHORS:
	@git log | git shortlog --numbered --summary -e | while read -r a rest || [ -n "$$rest" ]; do echo "$$rest"; done > AUTHORS

CONTRIBUTORS:
	@git log | git shortlog $(DRACUT_MAIN_VERSION).. --numbered --summary -e | while read -r a rest || [ -n "$$rest" ]; do echo "- $$rest"; done

=== debian/changelog ===
dracut (106-6) unstable; urgency=medium

  [ cacin ]
  * Drop nonexistent Recommends: dmraid (Closes: #1099698)

 -- Andreas Tille <tille@debian.org>  Fri, 11 Apr 2025 13:34:23 +0200

dracut (106-5) unstable; urgency=medium

  * disable upstream test 43

 -- Thomas Lange <lange@debian.org>  Sat, 22 Feb 2025 14:06:40 +0100

dracut (106-4) unstable; urgency=medium

  * skip upstream test 12, time out on Debian

 -- Thomas Lange <lange@debian.org>  Fri, 21 Feb 2025 17:53:33 +0100

dracut (106-3) unstable; urgency=medium

  * disable autopkgtest for s390x, Closes: #1096001
  * debian/rules: remove dracut.html which does not exist

 -- Thomas Lange <lange@debian.org>  Thu, 20 Feb 2025 11:02:07 +0100

dracut (106-2) unstable; urgency=medium

  * new patches (all accepted upstream):
    - test(ISCSI): skip root=ibft if qemu -acpitable is not supported
    - test(FULL-SYSTEMD): skip encrypted root if qemu -smbios is not supported
    - test: use persistent names for network devices
    - fix(dracut-install): install compressed blobs that match wildcard fwpath
      (LP: #2095518)
  * autopkgtest: explicitly depend on ipxe-qemu
  * dracut-core: install upstream dracut.conf.d subdirectories
    (to be used with --confdir)
  * Enable autopkgtest for s390x

 -- Benjamin Drung <bdrung@debian.org>  Thu, 13 Feb 2025 01:05:51 +0100

dracut (106-1) unstable; urgency=medium

  * New upstream release.
  * Update debian/watch to point to dracut-ng upstream
  * dracut-live: suggest isomd5sum (for checkisomd5 command) (Closes: #1095162)
  * dracut-core: install /usr/lib/kernel/install.d (Closes: #1082811)
  * Drop patches included upstream and refresh remaining patches
  * Move modules:
    - reserve range 50-59 to out of tree dracut modules
    - fix(shell-interpreter): move later in the module ordering
    - move 01systemd-sysusers to 60systemd-sysusers
  * dracut-core: remove moved upstream docs
  * dracut-core: drop dracut.html (please use man pages instead)
  * dracut-core: add new modules 01systemd-battery-check and 97systemd-emergency
  * test: reorganize tests (new numbering schema)
  * Run upstream autopkgtest as root
  * test: depend on dbus and systemd-container for TEST-41-FULL-SYSTEMD
  * new patches:
    - test: log error when constructing sysroot
    - test(FULL-SYSTEMD): skip systemd-network-management if missing
  * dracut-core: drop gawk dependency

 -- Benjamin Drung <bdrung@debian.org>  Fri, 07 Feb 2025 21:21:31 +0100

=== debian/control ===
Source: dracut
Section: utils
Priority: optional
Maintainer: Thomas Lange <lange@debian.org>
Uploaders: Benjamin Drung <bdrung@debian.org>
Build-Depends: asciidoc-base,
               debhelper-compat (= 13),
               docbook-xml,
               docbook-xsl,
               libkmod-dev,
               pkgconf,
               systemd-dev,
               xsltproc
Rules-Requires-Root: no
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/dracut
Vcs-Git: https://salsa.debian.org/debian/dracut.git
Homepage: https://github.com/dracut-ng/dracut-ng/wiki

Package: dracut-core
Architecture: any
Multi-Arch: foreign
Depends: cpio,
         dracut-install,
         e2fsprogs,
         kmod,
         udev,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: binutils,
            console-setup,
            cryptsetup,
            dmsetup,
            kpartx,
            lvm2,
            mdadm,
            systemd,
            systemd-cryptsetup,
            systemd-sysv,
            zstd
Breaks: dracut-live (<< 059-2), dracut-network (<< 057+157-2)
Replaces: dracut-live (<< 059-2), dracut-network (<< 057+157-2)
Description: dracut is an event driven initramfs infrastructure (core tools)
 Unlike existing initramfs's, this is an attempt at having as little as
 possible hard-coded into the initramfs as possible.  The initramfs has
 (basically) one purpose in life -- getting the rootfs mounted so that
 it can transition to the real rootfs.  This is all driven off of
 device availability.  Therefore, instead of scripts hard-coded to do
 various things, it depends on udev to create device nodes and
 to detect the rootfs.
 Having the root on MD, LVM2, LUKS is supported as well as NFS, iSCSI,
 NBD and FCOE with dracut-network.

Package: dracut
Architecture: all
Multi-Arch: foreign
Depends: dracut-core (<< ${binary:Version}+b+~),
         dracut-core (>= ${binary:Version}),
         linux-base,
         ${misc:Depends}
Suggests: dracut-network
Provides: linux-initramfs-tool
Conflicts: initramfs-tools, live-tools
Description: Initramfs generator using udev
 This package builds a bootable initramfs for Linux kernel packages.  The
 initramfs is loaded along with the kernel and is responsible for
 mounting the root filesystem and starting the main init system.

Package: dracut-install
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: dracut-core (<< 060+5-7~)
Replaces: dracut-core (<< 060+5-7~)
Description: dracut is an event driven initramfs infrastructure (dracut-install)
 This package just contains the dracut-install command to be used by
 initramfs generating tools.

Package: dracut-network
Architecture: all
Depends: dracut-core,
         iputils-arping,
         isc-dhcp-client | systemd | connman | network-manager,
         ${misc:Depends}
Recommends: curl, iscsiuio, nbd-client, nfs-common, open-iscsi
Breaks: dracut-core (<< 105)
Replaces: dracut-core (<< 105)
Description: dracut is an event driven initramfs infrastructure (network modules)
 Package to build a dracut initramfs with network support. This
 includes dracut modules for NFS, CIFS, iSCSI, HTTP, NBD, FCP and FCOE.

Package: dracut-squash
Architecture: all
Depends: dracut-core, squashfs-tools, ${misc:Depends}
Breaks: dracut-core (<< 050-1)
Replaces: dracut-core (<< 050-1)
Description: dracut is an event driven initramfs infrastructure (squashfs modules)
 Package to build an initramfs with most files in a squashfs image.
 .
 This package provides a dracut module to build an initramfs, but
 store most files in a squashfs image, result in a smaller initramfs
 size and reduce runtime memory usage.

Package: dracut-live
Architecture: all
Depends: dmsetup, dracut-core, ${misc:Depends}
Recommends: dracut-network
Suggests: isomd5sum
Breaks: dracut-core (<< 050-1), dracut-network (<< 050-1)
Replaces: dracut-core (<< 050-1), dracut-network (<< 050-1)
Description: dracut is an event driven initramfs infrastructure (live image modules)
 Package to build a dracut initramfs with live image capabilities.
 .
 This package requires everything which is needed to build an
 initramfs with dracut, with live image capabilities, like Live CDs.

Package: dracut-config-generic
Architecture: all
Depends: dracut-core, ${misc:Depends}
Multi-Arch: foreign
Description: dracut is an event driven initramfs infrastructure
 This is the dracut configuration to turn off hostonly image generation

Package: dracut-config-rescue
Architecture: all
Depends: dracut-core, ${misc:Depends}
Multi-Arch: foreign
Description: dracut is an event driven initramfs infrastructure
 This is the dracut configuration to turn on rescue image generation

Package: dracut-test
Architecture: all
Depends: dracut-core, ${misc:Depends}
Breaks: dracut-core (<< 105)
Replaces: dracut-core (<< 105)
Description: dracut is an event driven initramfs infrastructure (test modules)
 This package provides the Dracut modules and configuration files for the
 Dracut test suite. This package is intended for testing Dracut itself
 and is of no use for ordinary users. If you're not sure about this package,
 you don't need it.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
DPKG_EXPORT_BUILDTOOLS=1
-include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DRACUT_MAIN_VERSION=$(DEB_VERSION_UPSTREAM_REVISION)
export DRACUT_FULL_VERSION=$(DEB_VERSION)
# For "make install" to not install files needed for tests
export enable_test=no

deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --systemdsystemunitdir=/$(deb_systemdsystemunitdir) --libdir=/usr/lib
	$(SHELL) debian/fix-revdate
	mv dracut-version.sh dracut-version.sh.orig
	echo '#!/bin/sh' > dracut-version.sh
	echo "DRACUT_VERSION=$${DRACUT_FULL_VERSION}" >> dracut-version.sh

override_dh_fixperms-arch:
	dh_fixperms
	find debian/ -name "*.sh" | grep modules.d | xargs chmod 755

override_dh_fixperms-indep:
	dh_fixperms
	find debian/ -name "*.sh" | grep modules.d | xargs chmod 755
	rm -f debian/*/usr/lib/dracut/modules.d/98dracut-systemd/*.adoc
	rm -f debian/*/usr/lib/dracut/modules.d/98dracut-systemd/*.8
ifneq ($(DEB_HOST_ARCH), s390x)
	for m in 80cms 81cio_ignore 91zipl 95dasd 95dasd_mod \
		95dcssblk 95zfcp \
		95znet; do \
		rm -rf debian/*/usr/lib/dracut/modules.d/$$m ; \
	done
else
	rm -rf debian/*/usr/lib/dracut/modules.d/00warpclock
endif

override_dh_auto_test:

override_dh_install:
	dh_install
	dh_install -pdracut-core $(deb_systemdsystemunitdir)

override_dh_clean:
	if test -e dracut-version.sh.orig ; then \
	   mv -f dracut-version.sh.orig dracut-version.sh ;\
	fi
	dh_clean dracut.pc Makefile.inc src/skipcpio/skipcpio src/util/util
	if test -d .git; then \
		git status|grep modified: | awk '/.adoc/ {print $$2}' | xargs -r git checkout;\
    fi

=== debian/tests/control ===
# Skip following test cases:
# * TEST-23-IMSM: dmraid was removed from Debian
# * TEST-61-MULTINIC: disabled in upstream CI since 2023-01-02
# * TEST-62-BONDBRIDGEVLAN: https://github.com/dracutdevs/dracut/issues/2328
# * TEST-70-ISCSI: iscsiuio.socket missing, see https://bugs.debian.org/1056733
# * TEST-71-ISCSI-MULTI: iscsiuio.socket missing, see https://bugs.debian.org/1056733
# arm64, armhf, ppc64el, and s390x need upstream support: https://github.com/dracutdevs/dracut/issues/2493
Features: test-name=upstream-dracut-core
Test-Command: debian/tests/run-upstream-tests SKIP="12 23 30 43 60 61 62 70 71 72"
Architecture: amd64
Restrictions: allow-stderr, needs-root
Depends: btrfs-progs,
         busybox,
         cryptsetup,
         dbus,
         dracut-core,
         dracut-test,
         fdisk,
         ipxe-qemu,
         kbd,
         linux-image-generic,
         lvm2,
         make,
         mdadm,
         mount,
         ovmf,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         squashfs-tools,
         systemd-boot-efi [amd64 arm64 armhf riscv64],
         systemd-container,
         systemd-coredump,
         systemd-cryptsetup,
         systemd-repart,
         systemd-sysv,
         systemd-ukify,
         util-linux,
         zstd

Features: test-name=upstream-dracut-live
Test-Command: debian/tests/run-upstream-tests TESTS="30"
Architecture: amd64
Restrictions: allow-stderr, needs-root
Depends: btrfs-progs,
         busybox,
         dracut-live,
         dracut-test,
         fdisk,
         ipxe-qemu,
         kbd,
         linux-image-generic,
         make,
         mount,
         parted,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         squashfs-tools,
         systemd-sysv,
         util-linux,
         zstd

Features: test-name=upstream-dracut-network-nfs
Test-Command: debian/tests/run-upstream-tests TESTS="60"
Architecture: amd64
Restrictions: allow-stderr, needs-root
Depends: dracut-live,
         dracut-network,
         dracut-test,
         iproute2,
         ipxe-qemu,
         isc-dhcp-client,
         isc-dhcp-server,
         linux-image-generic,
         make,
         mount,
         nfs-kernel-server,
         procps,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         systemd,
         systemd-sysv,
         sysvinit-utils,
         util-linux,
         zstd

Features: test-name=upstream-dracut-network-nbd
Test-Command: debian/tests/run-upstream-tests TESTS="72"
Architecture: amd64
Restrictions: allow-stderr, needs-root
Depends: cryptsetup,
         dracut-network,
         dracut-test,
         iproute2,
         ipxe-qemu,
         isc-dhcp-client,
         isc-dhcp-server,
         linux-image-generic,
         lvm2,
         make,
         mdadm,
         mount,
         nbd-client,

## dracut 107

=== debian/changelog ===
dracut (107-2) unstable; urgency=medium

  * autopkgtest: depend on curl for test 60-NFS
  * Bump Standards-Version to 4.7.2
  * Add update-initramfs (derived from initramfs-tools) (LP: #2098525)
  * Add bash completion for update-initramfs (LP: #2103540)
  * autopkgtest: replace qemu-kvm by qemu-system-native
  * Fix shellcheck in Debian packaging scripts
  * fix(lsinitrd): resolve initrd to real path (LP: #2116183)
  * Add autopkgtest for lsinitrd
  * dracut-network: default to systemd-networkd as network manager
  * dracut-core: silence "cannot break line" groff warnings
  * Run syncheck on package test phase

 -- Benjamin Drung <bdrung@debian.org>  Tue, 29 Jul 2025 23:31:39 +0200

dracut (107-1) unstable; urgency=medium

  [ Thomas Lange ]
  * new upstream 107
  * drop 90overlay-root in favor of the overlayfs, Closes: #1017039
  * refresh patches, drop patches included upstream
  * rename module systemd-sysusers
  * add module 45simpledrm
  * update revdate for man pages

  [ Benjamin Drung ]
  * Stop shipping the dmraid module (Closes: #1099698)
  * Set -H --hostonly-mode=sloppy as default arguments via a config file
  * d/copyright: fix lintian's old-fsf-address-in-copyright-file
  * autopkgtest:
    - enable test 12 but skip using kernel-install due to bug #1104848
    - Remove possible masked systemd-udevd to avoid test 10 to fail

 -- Thomas Lange <lange@debian.org>  Tue, 20 May 2025 11:21:44 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,19 @@
 Priority: optional
 Maintainer: Thomas Lange <lange@debian.org>
 Uploaders: Benjamin Drung <bdrung@debian.org>
-Build-Depends: asciidoc-base,
-               debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 13),
+               asciidoc-base,
+               bash-completion,
                docbook-xml,
                docbook-xsl,
                libkmod-dev,
                pkgconf,
+               shellcheck [!i386 !m68k !powerpc !sh4 !x32] <!nocheck>,
+               shfmt [!i386 !m68k !powerpc !sh4 !x32] <!nocheck>,
                systemd-dev,
                xsltproc
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/dracut
 Vcs-Git: https://salsa.debian.org/debian/dracut.git
 Homepage: https://github.com/dracut-ng/dracut-ng/wiki
@@ -24,6 +27,7 @@
          dracut-install,
          e2fsprogs,
          kmod,
+         systemd-sysv | initscripts | sysvinit-core,
          udev,
          ${misc:Depends},
          ${shlibs:Depends}
@@ -36,7 +40,6 @@
             mdadm,
             systemd,
             systemd-cryptsetup,
-            systemd-sysv,
             zstd
 Breaks: dracut-live (<< 059-2), dracut-network (<< 057+157-2)
 Replaces: dracut-live (<< 059-2), dracut-network (<< 057+157-2)
@@ -79,7 +82,7 @@
 Architecture: all
 Depends: dracut-core,
          iputils-arping,
-         isc-dhcp-client | systemd | connman | network-manager,
+         systemd | network-manager | isc-dhcp-client | connman,
          ${misc:Depends}
 Recommends: curl, iscsiuio, nbd-client, nfs-common, open-iscsi
 Breaks: dracut-core (<< 105)

=== debian/rules ===
--- 
+++ 
@@ -15,14 +15,13 @@
 deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)
 
 %:
-	dh $@
+	dh $@ --with bash-completion
 
 override_dh_auto_configure:
 	dh_auto_configure -- --systemdsystemunitdir=/$(deb_systemdsystemunitdir) --libdir=/usr/lib
 	$(SHELL) debian/fix-revdate
-	mv dracut-version.sh dracut-version.sh.orig
-	echo '#!/bin/sh' > dracut-version.sh
-	echo "DRACUT_VERSION=$${DRACUT_FULL_VERSION}" >> dracut-version.sh
+	cp dracut-version.sh dracut-version.sh.orig
+	sed -i 's;^\(DRACUT_VERSION=\).*;\1$(DRACUT_FULL_VERSION);' dracut-version.sh
 
 override_dh_fixperms-arch:
 	dh_fixperms
@@ -44,6 +43,7 @@
 endif
 
 override_dh_auto_test:
+	make syncheck
 
 override_dh_install:
 	dh_install

=== debian/tests/control ===
--- 
+++ 
@@ -1,12 +1,17 @@
+Tests: lsinitrd
+Depends: dracut, linux-image-generic, zstd
+Restrictions: needs-root, superficial
+
 # Skip following test cases:
 # * TEST-23-IMSM: dmraid was removed from Debian
+# * TEST-43-KERNEL-INSTALL: kernel-install issue, see https://bugs.debian.org/1104848
 # * TEST-61-MULTINIC: disabled in upstream CI since 2023-01-02
 # * TEST-62-BONDBRIDGEVLAN: https://github.com/dracutdevs/dracut/issues/2328
 # * TEST-70-ISCSI: iscsiuio.socket missing, see https://bugs.debian.org/1056733
 # * TEST-71-ISCSI-MULTI: iscsiuio.socket missing, see https://bugs.debian.org/1056733
 # arm64, armhf, ppc64el, and s390x need upstream support: https://github.com/dracutdevs/dracut/issues/2493
 Features: test-name=upstream-dracut-core
-Test-Command: debian/tests/run-upstream-tests SKIP="12 23 30 43 60 61 62 70 71 72"
+Test-Command: debian/tests/run-upstream-tests SKIP="23 30 43 60 61 62 70 71 72"
 Architecture: amd64
 Restrictions: allow-stderr, needs-root
 Depends: btrfs-progs,
@@ -26,7 +31,7 @@
          ovmf,
          qemu-efi-aarch64 [arm64],
          qemu-efi-arm [armhf],
-         qemu-kvm,
+         qemu-system-native,
          seabios [ppc64el],
          squashfs-tools,
          systemd-boot-efi [amd64 arm64 armhf riscv64],
@@ -56,7 +61,7 @@
          parted,
          qemu-efi-aarch64 [arm64],
          qemu-efi-arm [armhf],
-         qemu-kvm,
+         qemu-system-native,
          seabios [ppc64el],
          squashfs-tools,
          systemd-sysv,
@@ -67,7 +72,8 @@
 Test-Command: debian/tests/run-upstream-tests TESTS="60"
 Architecture: amd64
 Restrictions: allow-stderr, needs-root
-Depends: dracut-live,
+Depends: curl,
+         dracut-live,
          dracut-network,
          dracut-test,
          iproute2,
@@ -81,7 +87,7 @@
          procps,
          qemu-efi-aarch64 [arm64],
          qemu-efi-arm [armhf],
-         qemu-kvm,
+         qemu-system-native,
          seabios [ppc64el],
          systemd,
          systemd-sysv,
@@ -95,14 +101,3 @@
 Restrictions: allow-stderr, needs-root
 Depends: cryptsetup,
          dracut-network,
-         dracut-test,
-         iproute2,
-         ipxe-qemu,
-         isc-dhcp-client,
-         isc-dhcp-server,
-         linux-image-generic,
-         lvm2,
-         make,
-         mdadm,
-         mount,
-         nbd-client,
